import sys
import os
sys.path.append(os.getcwd())
sys.path.append('/home/lyz/pysot-toolkit-master')
from pysot.datasets import DatasetFactory
from pysot.utils.region import vot_overlap
import numpy as np
from dcda_tracker import Dcda_Tracker
import os
import torch
import cv2
from defaults import _C as cfg
from vgg_backbone import build_vgg16
from Utils import get_axis_aligned_bbox

otb_root = '/home/lyz/VOT2018'
result_path = '/home/lyz/TADT-python-master/'
vgg16_model_mat_path = '/home/lyz/TADT-python-master'

dataset = DatasetFactory.create_dataset(name = 'VOT2018', dataset_root = otb_root, load_img = False)

device = torch.device('cuda' if torch.cuda.is_available() else 'cpu')

model = build_vgg16(cfg)
conv_5_1 = model.get_os_block()
if not os.path.exists(result_path):
    os.mkdir(result_path)
for video in dataset:
    # if video.name != 'basketball':
    #    continue
    frame_counter = 0
    pred_bboxes = []
    print('video:',video.name)
    fail=0
    for idx, (img_path, gt_bbox) in enumerate(zip(video.img_names, video.gt_traj)):
        print('\r' + 'frame:',idx,'Failure:',fail, end='', flush=True)
        ggt = gt_bbox
        tmping = cv2.imread(img_path)
        gt_bbox = get_axis_aligned_bbox(np.array(gt_bbox))
        gt_bbox = [int(gt_bbox[0]), int(gt_bbox[1]),int(gt_bbox[2]),int(gt_bbox[3])]
        if idx == frame_counter:
            # gt_bbox = video.init_rect
            target_location = np.array(gt_bbox)
            gt = target_location.copy()
            model.set_os_block(conv_5_1)
            tracker = Dcda_Tracker(cfg, model = model, device = device, display = True)
            tracker.initialize_dcda(img_path, target_location, flip=True)
            tracker.initialize_dcda(img_path, gt, flip=False)
            pred_bboxes.append(1)
        elif idx > frame_counter:
            pred_bbox,_ = tracker.tracking(img_path, idx)
            overlap = vot_overlap(pred_bbox, ggt, (tmping.shape[1], tmping.shape[0]))
            if overlap>0:
                pred_bboxes.append(pred_bbox)
            else:
                fail+=1
                model.set_os_block(conv_5_1)
                tracker = Dcda_Tracker(cfg, model = model, device = device, display = True)
                target_location = np.array(gt_bbox)
                gt = target_location.copy()
                tracker.initialize_dcda(img_path, target_location, flip=True)
                tracker.initialize_dcda(img_path, gt, flip=False)
                pred_bboxes.append(2)
                frame_counter = idx + 5
        else:
            pred_bboxes.append(0)

    tracker.results = pred_bboxes
